#include <stdio.h>
#include "pdc2.h"
#include <xgrafix.h>
#include <string.h>

void XGWrite(void *, int, int, FILE *, char *); 
void XGRead(void *, int, int, FILE *, char *);
int err_end(char *);

/****************************************************************/
char **buffer,**buffer2,**buffer3,**buffer4,**buffer5,**buffer6,**buffer7,**buffer8;

/* void InitVars ()
{
 SetUpNewVar(&cflag,"MYflag","integer");
}
*/

int InitWindows(argc,argv)
int argc;
 char **argv;
{
  int i, j,num;
  

    /*********************************************/
  
/* Structures for actual vx and vy */

  /*********************************************/
  buffer2 = (char **)malloc(nsp*sizeof(char *));
  for(i=0; i<nsp; i++) {
    buffer2[i] = (char *)malloc(25*sizeof(char));
    sprintf(buffer2[i], "Vx-X Phase Space %d", i+1);

    XGSet2D("linlin", "X", buffer2[i], "closed", 200, 200, dr, vrscale[i],
            False, True, -rmax, rmax, 1.0,1.0);

    XGScat2D(x[i], vx1[i], &np[i], i);
  }

  buffer3 = (char **)malloc(nsp*sizeof(char *));
  for(i=0; i<nsp; i++)
  {
    buffer3[i] = (char *)malloc(25*sizeof(char));
    sprintf(buffer3[i], "Vx-Vy Phase Space %d", i+1);

    XGSet2D("linlin", "Vx", buffer3[i], "closed", 500, 100, vthscale[i],
            vrscale[i],True,True,0.0,0.0,0.0,0.0); 

    XGScat2D(vx1[i], vy1[i], &np[i], i);
  }

/*
*/
  /*********************************************/


 /* Set up each window structure              */

  buffer4 = (char **)malloc(nsp*sizeof(char *));
  for(i=0; i<nsp; i++) {
    buffer4[i] = (char *)malloc(25*sizeof(char));
    sprintf(buffer4[i], "Vr-R Phase Space %d", i+1);
    
    XGSet2D("linlin", "R", buffer4[i], "closed", 200, 200, dr, vrscale[i],
            False, True, rmin, rmax, 0.0,0.0);
    
    XGScat2D(r[i], vr[i], &np[i], i);
  }
 
  /*********************************************/
/*
*/
  buffer5 = (char **)malloc(nsp*sizeof(char *));
  for(i=0; i<nsp; i++)
  {
    buffer5[i] = (char *)malloc(30*sizeof(char));
    sprintf(buffer5[i], "R-Vth Phase Space %d", i+1);
    
    XGSet2D("linlin", "R", buffer5[i], "closed", 500, 100, dr,
	    vthscale[i], True,True,0.0,0.0,0.0,0.0);
    
    XGScat2D(r[i], vth[i], &np[i], i);
  }
 
  /*********************************************/
  buffer6 = (char **)malloc(nsp*sizeof(char *));
  for(i=0; i<nsp; i++)
  {
    buffer6[i] = (char *)malloc(25*sizeof(char));
    sprintf(buffer6[i], "Density (r,th) %d", i+1);

  XGSet3D("linlinlin", "R", "Theta", buffer6[i], 45.0, -45.0, "closed", 500, 
	400, 1.0, 1.0, nc2p/drdthzlength, False, False, True, rmin, rmax,
        0.0, 2*PI,0.0,0.0);
  
  XGSurf(r_array, th_array, srho[i], &ngr, &ngt, 3);
  
  sprintf(buffer6[i], "Density (x,y) %d", i+1);

  XGSet3D("linlinlin", "x", "y", buffer6[i], 0, 0, "closed", 500, 400, 
     	1.0, 1.0, nc2p/drdthzlength, False, False, True, -rmax, rmax, 
	-rmax, rmax, 0.0,0.0);
  XGIRSurf(x_i, y_i, srho[i], &ngr, &ngt, 3);
  }
  if (rhoback) {
    XGSet3D("linlinlin", "x", "y","Dust Density (x,y)", 0, 0, "closed", 500, 
     400, 1.0, 1.0, nc2p, False, False, True, -rmax, rmax, -rmax, rmax, 0, 0);
    XGIRSurf(x_i, y_i, dust_rho, &ngr, &ngt, 3);
  }
  /*********************************************/
  buffer=(char **)malloc(nsp*sizeof(char *));
  if(!buffer)
    err_end("Couldn't malloc buffer!");
  for(i=0; i<nsp; i++)  {
    buffer[i] = (char *)malloc(25*sizeof(char));
    sprintf(buffer[i], "R-Theta  %d", i+1);
    XGSet2D("linlin", "Theta", buffer[i], "closed", 300, 10, dth, dr,
          False, False, 0.0, TWOPI, rmin, rmax);
    XGScat2D(th[i], r[i], &np[i], i);
  }
 
  /*********************************************/
  buffer8 = (char **)malloc(nsp*sizeof(char *));
  if(!buffer8)
    err_end("Couldn't malloc buffer8!");

  for(i=0; i<nsp; i++)  {
    buffer8[i] = (char *)malloc(25*sizeof(char));
    sprintf(buffer8[i], "X-Y %d", i+1);

    XGSet2D("linlin", "X", buffer8[i], "closed", 300, 10, dr, dr,
	    False, False, -rmax, rmax,-rmax, rmax);
    
    XGScat2D(x[i], y[i], &np[i], i);
    
    if (cent_cond) XGCurve(boundymn,boundxmn,&boundn,4); 
    XGCurve(boundymx,boundxmx,&boundn,4);
  }
/*
  if (nsp>1) {
    XGSet2D("linlin", "X", "X-Y all", "closed", 300, 40, dr, dr,
            False, False, -rmax, rmax,-rmax, rmax);
   
    for(i=0; i<nsp; i++) XGScat2D(x[i], y[i], &np[i], i);
    if (cent_cond) XGCurve(boundymn,boundxmn,&boundn,4);
    XGCurve(boundymx,boundxmx,&boundn,4);
  }
*/
  /*********************************************/

  XGSet3D("linlinlin", "R", "Theta", "Phi(r,theta)", 45.0, -45.0, "closed", 10, 15,
	  1.0, 1.0, 1.0, False, False, True, rmin, rmax, 0.0, 2*PI,-1.0,1.0);
  
  XGSurf(r_array, th_array, phi, &ngr, &ngt, 3);
  

  if (cflag)
  { 
  XGSet3D("linlinlog", "R", "m", "Phik(r,m)", 45.0, 135.0, "closed", 100, 150,
   1.0, 1.0, 1.0, False, False, True, rmin, rmax, 0.0, (SCALAR)fftngt, 0.0, 0.0);
  XGSurf(r_array, k_array, fft_phi, &ngr, &fftngt, 3);

  XGSet2D("linlin", "t", "max_mode at midplane", "closed", 300, 10, 1, 1,
            True, True, 0.0, 0.0, 0.0, 0.0);
  XGCurve(t_array, mode_hist, &hist_hi, 3);

/*  XGSet3D("linlinlin", "m", "t", "Phik(m,t)", 45,-45, "closed", 100, 150,
    1,1,1,True, True, True, 1, (SCALAR)(num_modes2), 0, hist_hi, 0, 0);
  XGSurf(k_array+modsrt, t_array, mode_hist, &num_modes2, &mode_hist_hi, 3);
*/

  XGSet2D("linlin", "t", "center of mass ", "closed", 360, 10, 1, dr,
            True, True, 0.0, 0.0, 0.0, 0.0);
  XGCurve(t_array, cem_hist, &hist_hi, 2);

  XGSet2D("linlin", "t", "angular momentum", "closed", 400, 50, 1,dr/vrscale[0],
            True, True, 0.0, 0.0, 0.0, 0.0);
  XGCurve(t_array, a_momentum_hist, &hist_hi, 4);
  }

  XGSet3D("linlinlin", "X", "Y", "Phi_i(x,y)", 0, 0, "closed", 10, 15,
	  1.0, 1.0, 1.0, False, False, True, -rmax, rmax, -rmax, rmax,0.0,0.0);
  XGIRSurf(x_i, y_i, phi, &ngr, &ngt, 3);
 
/*  XGSet3D("linlinlin", "R", "theta", "Phi_k(x,y)", 135.0, 225.0, "closed", 10, 15, 1.0, 1.0, 1.0, True, True, True, -rmax, rmax, -rmax, rmax,0.0,0.0);
  XGSurf(r_array, th_array, phik, &ngr, &ngt, 3); */

/* --------------- 2D diagnostics ---- by leehj ---------------*/
  XGSet2D("linlin", "r (m)", "phi(r,0)", "closed", 10, 10, 1.0, 1.0,
            False, True, rmin, rmax, 0.0, 0.0);
  XGCurve(r_array, phi_r_show, &ngr, 3);

  XGSet2D("linlin", "r (m)", "e_r(r,0)", "closed", 10, 10, 1.0, 1.0,
            False, True, rmin, rmax, 0.0, 0.0);
  XGCurve(r_array, er_r_show, &ngr, 3);

  XGSet2D("linlin", "r (m)", "e_th(r,0)", "closed", 10, 10, 1.0, 1.0,
            False, True, rmin, rmax, 0.0, 0.0);
  XGCurve(r_array, eth_r_show, &ngr, 3);

  XGSet2D("linlin", "r (m)", "density (r,0)", "closed", 10, 10, 1.0, 
            nc2p/drdthzlength, False, True, rmin, rmax, 0.0, 0.0);
  for (i=0;i<nsp;i++) XGCurve (r_array, srho_r_show[i], &ngr, i);


  XGSet2D("linlin", "theta (rad)", "e_th(mid_r, theta)", "closed", 
            10, 10, 1.0, 1.0, False, True, 0.0, 2*PI, 0.0, 0.0);
  XGCurve(th_array, eth[ncr/2], &ngt, 3);

  XGSet2D("linlin", "theta (rad)", "density(mid r,theta)", "closed", 
            10, 10, 1.0, nc2p/drdthzlength, False, True, 0.0, 2*PI, 0.0, 0.0);
  for (i=0;i<nsp;i++) XGCurve(th_array, srho1[i][ncr/2], &ngt, i);
 
  XGSet2D("linlin", "theta (rad)", "density(r_min,theta)", "closed",
            10, 10, 1.0, nc2p/drdthzlength, False, True, 0.0, 2*PI, 0.0, 0.0);
  for (i=0;i<nsp;i++) XGCurve(th_array, srho1[i][0], &ngt, i);

  XGSet2D("linlin", "theta (rad)", "phi(mid r,theta)", "closed",
            50, 20, 1.0, 1.0, False, True, 0.0, 2*PI, 0.0, 0.0);
  XGCurve(th_array, phi[ncr/2], &ngt, 3);
/* --------------------------------------------------*/
  XGSet3D("linlinlin", "X", "Y", "Rho_i(x,y)", 0, 0, "closed", 10, 15,
	  1.0, 1.0, 1.0, False, False, True, -rmax, rmax, -rmax, rmax,0.0,0.0);
  XGIRSurf(x_i, y_i, rho, &ngr, &ngt, 3);

  XGSet3D("linlinlin", "R", "Theta", "Rho(r,theta)", 90.0, -90.0, "closed", 500,
         400, 1.0, 1.0, 1.0, False, False, True, rmin, rmax, 6.0, 2*PI,0.0,0.0);
  
  XGSurf(r_array, th_array, rho, &ngr, &ngt, 3);


/*  if (!cent_cond) */
  {
  XGSet3D("linlinlog", "R", "m", "Rhok(r,m)", 45.0, 45.0, "closed", 100, 150,
     1.0, 1.0, 1.0, True, True, True, rmin, rmax, 0.0, (SCALAR)fftngt,0.0,0.0);
  
  XGSurf(r_array, k_array, fft_rho, &ngr, &fftngt, 3);
	}
 
  XGSet3D("linlinlin", "R", "Theta", "Er(r,theta)", 45.0, -45.0, "closed", 100, 150,
	  1.0, 1.0, 1.0, False, False, True, rmin, rmax, 0.0, 2*PI,0.0,0.0);
  
  XGSurf(r_array, th_array, er, &ngr, &ngt, 3);



  XGSet3D("linlinlin", "R", "Theta", "Eth(r,theta)", 45.0, 135.0, "closed", 100, 150,
	  1.0, 1.0, 1.0, False, False, True, rmin, rmax, 0.0, 2*PI,-1.0,1.0);
  
  XGSurf(r_array, th_array, eth, &ngr, &ngt, 3);



  XGSet3D("linlinlin", "X", "Y", "Eth_i(x,y)", 45.0, 225.0, "closed", 10, 15,
	  1.0, 1.0, 1.0, False, False, True, -rmax, rmax, -rmax, rmax,0.0,0.0);
  
  XGIRSurf(x_i, y_i, eth, &ngr, &ngt, 3);


  XGSet3D("linlinlin", "X", "Y", "Er_i(x,y)", 45.0, 225.0, "closed", 10, 15,
	  1.0, 1.0, 1.0, False, False, True, -rmax, rmax, -rmax, rmax,0.0,0.0);
  
  XGIRSurf(x_i, y_i, er, &ngr, &ngt, 3);

  /*------------------ E vector field --------------------*/

  XGSetVec("vecvec", "Theta", "R", "E(r,th)", "closed", 700, 175, 1.0, 1.0, 
	False, False, 0, 2*PI, rmin, rmax);

  XGVector(th_array2, r_array2, eth2, er2, &hngt, &hngr, 3);

  if (nfft)
  {

/* Time average Potential */

  XGSet3D("linlinlin", "R", "Theta", "Time Ave Phi(r,theta)", 45.0, -45.0,"closed",
 10, 15, 1.0, 1.0, 1.0, False, False, True, rmin, rmax, 0.0, 2*PI,-1.0,1.0);
  
  XGSurf(r_array, th_array, phi_ave_show, &ngr, &ngt, 3);
  
 
  XGSet3D("linlinlin", "X", "Y", "Time Ave Phi_i(x,y)", 0, 0, "closed", 10, 
15,1.0, 1.0, 1.0, False, False, True, -rmax, rmax, -rmax, rmax,0.0,0.0);
  
  XGIRSurf(x_i, y_i, phi_ave_show, &ngr, &ngt, 3);


/* Time average Er */

  XGSet3D("linlinlin", "R", "Theta", "Time Ave Er(r,theta)", 45.0, -45.0,"closed",
 10, 15, 1.0, 1.0, 1.0, False, False, True, rmin, rmax, 0.0, 2*PI,-1.0,1.0);
  
  XGSurf(r_array, th_array, er_ave_show, &ngr, &ngt, 3);
  
 
  XGSet3D("linlinlin", "X", "Y", "Time Ave Er_i(x,y)", 45.0, 225.0, "closed", 10, 
15,1.0, 1.0, 1.0, False, False, True, -rmax, rmax, -rmax, rmax,0.0,0.0);
  
  XGIRSurf(x_i, y_i, er_ave_show, &ngr, &ngt, 3);

/* Time average E Theta */

  XGSet3D("linlinlin", "R", "Theta", "Time Ave Eth(r,theta)", 45.0, 135.0,"closed",
 10, 15, 1.0, 1.0, 1.0, False, False, True, rmin, rmax, 0.0, 2*PI,-1.0,1.0);
  
  XGSurf(r_array, th_array, eth_ave_show, &ngr, &ngt, 3);
  
 
  XGSet3D("linlinlin", "X", "Y", "Time Ave Eth_i(x,y)", 45.0, 225.0, "closed", 10, 
15,1.0, 1.0, 1.0, False, False, True, -rmax, rmax, -rmax, rmax,0.0,0.0);
  
  XGIRSurf(x_i, y_i, eth_ave_show, &ngr, &ngt, 3);

/* Spectral Components of time varying stuff */

    /*********************************************/

    XGSet2D("linlog", "Freq", "Mag of Mid V(f)", "close", 100, 250, 1.0, 1.0, False, True, 0.0, 1e9, 0.0, 0.0);

    XGCurve(f_array, phi_fft, &freq_hi, 4);

    /*********************************************/

    XGSet2D("linlog", "Freq", "Mag of I(f)", "close", 100, 250, 1.0, 1.0, False, True, 0.0, 1e9, 0.0, 0.0);

    XGCurve(f_array, cur_fft, &freq_hi, 4);

    /*********************************************/

    XGSet2D("linlog", "Freq", "Mag of Mid Er(f)", "close", 100, 250, 1.0, 1.0, False, True, 0, 1e9, 0.0, 0.0);

    XGCurve(f_array, er_fft, &freq_hi, 4);

    /*********************************************/

    XGSet2D("linlog", "Freq", "Mag of Mid Eth (f)", "close", 100, 250, 1.0, 1.0, False, True, 0, 1e9, 0.0, 0.0);

    XGCurve(f_array, eth_fft, &freq_hi, 4);

    /*********************************************/

		}

  XGSet2D("linlin", "Time", "Number(t)", "closed", 100, 400, 1.0, 1.0, 
	  True, True,1.0,1.0,1.0,1.0);

  for (i=nsp-1; i>=0; i--) 
    XGCurve(t_array, np_hist[i], &hist_hi, i);


  if (cflag) {
  XGSet2D("linlin", "Time", "Kinetic Energy", "closed", 100, 400, 1.0, 1.0, 
	  True, True,1.0,1.0,1.0,1.0);
  for (i=nsp-1; i>=0; i--) 
    XGCurve(t_array, kes_hist[i], &hist_hi, i);
  XGCurve(t_array, ke_hist, &hist_hi, 2); 
  }

  XGSet2D("linlin", "Time", "Field Energy", "closed", 150, 450, 1.0, 1.0,
          True, True,1.0,1.0,1.0,1.0);
  XGCurve(t_array, fe_hist, &hist_hi, 0);
  XGCurve(t_array, fe_hist_old, &hist_hi, 2);

  XGSet2D("linlin", "Time", "TE, FE, KE", "closed", 150, 450, 1.0, 1.0, 
	  True, True,1.0,1.0,1.0,1.0);
  XGCurve(t_array, te_hist, &hist_hi, 0); 
  XGCurve(t_array, ke_hist, &hist_hi, 2); 
  XGCurve(t_array, fe_hist, &hist_hi, 1);  

  buffer7 = (char **)malloc(25*sizeof(char *));

  if (cflag) {
    for(i=0; i<num_modes; i++) {
      buffer7[i] = (char *)malloc(10*sizeof(char));
      sprintf(buffer7[i], "ESE(%d)", i+modsrt);
    
      XGSet2D("linlog", "Time",buffer7[i], "closed", 150, 450, 1.0, 1.0, 
	    True, True,1.0,1.0,1.0,1.0);
      XGCurve(t_array, fes_hist[i], &hist_hi, i);
    } 

    XGSet2D("linlog", "Time","ESE total", "closed", 150, 450, 1.0, 1.0,
            True, True,1.0,1.0,1.0,1.0);
    for (i=0; i<num_modes; i++) XGCurve(t_array, fes_hist[i], &hist_hi, i);

    XGSet2D("linlog", "m","1/4 Phik(m)", "closed", 170, 400, 1.0, 1.0,
            False, True,0,32,1.0,1.0);
    XGCurve(k_array, loc_ese[0], &fftngt, 0);

    XGSet2D("linlog", "m","1/2 Phik(m)", "closed", 170, 400, 1.0, 1.0,
            False, True,0,32,1.0,1.0);
    XGCurve(k_array, loc_ese[1], &fftngt, 1);

    XGSet2D("linlog", "m","3/4 Phik(m)", "closed", 170, 400, 1.0, 1.0,
            False, True,0,32,1.0,1.0);
    XGCurve(k_array, loc_ese[2], &fftngt, 2);
  }    
  /*********************************************/

  XGSet2D("linlin", "Time", "Mid Potential(t)", "close", 500, 400, 1.0, 1.0, 
        True, True, 0.0, 0.0, 0.0, 0.0);
  XGCurve(t_array, com_phi_hist[1], &hist_hi, 2);
  XGCurve(t_array, com_phi_hist[2], &hist_hi, 3);
  /*********************************************/

  XGSet2D("linlin", "Time", "Center Potential(t)", "close", 700, 400, 1.0, 1.0, 	True, True, 0.0, 0.0, 0.0, 0.0);
  XGCurve(t_array, com_phi_hist[0], &hist_hi, 4);

  /*********************************************/

/* Er at r/2 theta/2 */

  XGSet2D("linlin", "Time", "Mid Er(t)", "close", 500, 400, 1.0, 1.0, True, True, 0.0, 0.0, 0.0, 0.0);

  XGCurve(t_array, com_e_hist[0], &hist_hi, 4);

  /*********************************************/
/* Eth at r/2 theta/2 */

  XGSet2D("linlin", "Time", "Mid Eth(t)", "close", 500, 400, 1.0, 1.0, True, True, 0.0, 0.0, 0.0, 0.0);

  XGCurve(t_array, com_e_hist[1], &hist_hi, 4);

  /*********************************************/



  if (cent_cond)
  {
  XGSet2D("linlin", "Time", "Current_density(t)", "closed", 600, 400, 1.0, 
          1./TWOPI/rmin, True, True,1.0,1.0,1.0,1.0);
 
  XGCurve(t_array, com_cur_hist, &hist_hi, 4);

  /*********************************************/

  XGSet2D("linlin", "Time", "Sigma(t)", "closed", 500, 500, 1.0, 1.0, True, True,1.0,1.0,1.0,1.0);

  XGCurve(t_array, sigma_hist, &hist_hi, 3);

  /*********************************************/

  XGSet2D("linlin", "Time", "Local LHS Potential(t)", "close", 300, 550,
            1.0, 1.0, True, True, 0.0, 0.0, 0.0, 0.0);

  XGCurve(Local_t_array, phi_hist[0], &thist_hi, 3);
  }
  /*********************************************/

  if (nfft) 
  {
    /*********************************************/

    XGSet2D("linlin", "Time", "Local Current(t)", "close", 300, 550, 1.0,
            1.0, True, True, 0.0, 0.0, 0.0, 0.0);

    XGCurve(Local_t_array, cur_hist, &thist_hi, 3);

    /*********************************************/

    XGSet2D("linlin", "Time", "Local Mid Potential(t)", "close", 300, 550,
            1.0, 1.0, True, True, 0.0, 0.0, 0.0, 0.0);
  
    XGCurve(Local_t_array, phi_hist[1], &thist_hi, 3);

    /*********************************************/

    XGSet2D("linlin", "Time", "Local Mid Er(t)", "close", 300, 550,
            1.0, 1.0, True, True, 0.0, 0.0, 0.0, 0.0);
 
    XGCurve(Local_t_array, e_hist[0], &thist_hi, 3);

    /*********************************************/

    XGSet2D("linlin", "Time", "Local Mid Eth(t)", "close", 300, 550,
            1.0, 1.0, True, True, 0.0, 0.0, 0.0, 0.0);
 
    XGCurve(Local_t_array, e_hist[1], &thist_hi, 3);

    /*********************************************/
  }
  for(i=0; i<ndiag; i++) {
    XGSet3D("linlinlin", "R", "Theta", rate_title[i], 45.0, 45.0, "closed",
              200, 150, 1, 1, nc2p/(dr*dth*zlength*dt), False, False, True, 
              rmin, rmax, 0, 2*PI, 0, 0);

    XGSurf(r_array, th_array, rate_show[i], &ngr, &ngt, 3);     
/*    XGSet2D("linlin", "X", rate_title[i], "closed", 100, 500, 1, 
            nc2p/(dr*dth*zlength*dt), False, True, 0, 2*PI, 0.0, 0.0);
    XGCurve(th_array, rate_show[i][ngr/2], &ngt, 3);     */
  }
  /*********************************************/


} 
int Quit()
{}
/****************************************************************
Quit()
{
  register int i,isp;
  
  for(isp=0; isp<nsp; isp++) {
    for(i=0; i< ngr; i++) {
      free(srho[isp][i]);
      free(srho0[isp][i]);
      free(srho1[isp][i]);
    }
    free(srho[isp]);
    free(srho0[isp]);
    free(srho1[isp]);
  }
  free(srho);
  free(srho0);
  free(srho1);

  for(i=0; i< ngr; i++) {
    free(r_array[i]);
    free(th_array[i]);
    free(k_array[i]);
    free(x_i[i]);
    free(y_i[i]);
    free(rho[i]);
    free(rhok[i]);
    free(fft_rho[i]);
    free(phi[i]);
    free(phik[i]);
    free(fft_phi[i]);
    free(phi_i[i]);
    free(er[i]);
    free(eth[i]);
    free(B[i]);
  }
  free(r_array);
  free(th_array);
  free(k_array);
  free(x_i);
  free(y_i);
  free(rho);
  free(rhok);
  free(fft_rho);
  free(phi);
  free(phik);
  free(fft_phi);
  free(phi_i);
  free(er);
  free(eth);
  free(sigma_wall);
  free(gam);
  free(A);
  free(C);
  free(B);

  for(i=0; i<nsp; i++)
  {
    free(r[i]);
    free(th[i]);
    free(x[i]);
    free(y[i]);
    free(vr[i]);
    free(vth[i]);
    free(vz[i]);
    free(w1[i]);
    free(w2[i]);
    free(w3[i]);
    free(w4[i]);
  }
  free(r);
  free(th);
  free(x);
  free(y);
  free(vr);
  free(vth);
  free(vz);
  free(w1);
  free(w2);
  free(w3);
  free(w4);
} */

/***************************************************************/
/* Dumping the current state of the system into a binary file. */
/* Note: the binary file is written in the format used by IBM  */
/* and DEC compatible machines (low bytes followed by high     */
/* bytes). For this Dump() and Restore() call the functions    */
/* myfread() and myfwrite().                                   */

char Revision[]={'2','.','m','0'};

int Dump(filename)
char *filename;
{
  register int i, isp;
  static int iter=1;
  SCALAR ftemp;
  char dmpfile[20], index[3];
  FILE *DMPFile;

  strcpy(dmpfile, filename);
  if (!theRunWithXFlag) {
    sprintf(index,"%d", iter);
    strcat(dmpfile, index);
    iter++;
  }
  if ((DMPFile = fopen(dmpfile, "w")) == NULL) {
    puts("Dump: open failed");
    return 0;
  }

  XGWrite(Revision, 1, 4, DMPFile, "char");
  ftemp = t;
  XGWrite(&ftemp, 4, 1, DMPFile, "SCALAR");
  XGWrite(&nsp, 4, 1, DMPFile, "int");
  XGWrite(np, 4, nsp, DMPFile, "int");
  for (isp=0; isp<nsp; isp++) {
      for (i=0; i<np[isp]; i++) {
	ftemp = r[isp][i]/fncr;
	XGWrite(&ftemp, 4, 1, DMPFile, "SCALAR");
	ftemp = th[isp][i]/fnct;
	XGWrite(&ftemp, 4, 1, DMPFile, "SCALAR");
	ftemp = vrscale[isp] * vr[isp][i];
	XGWrite(&ftemp, 4, 1, DMPFile, "SCALAR");
	ftemp = vthscale[isp] * vth[isp][i];
	XGWrite(&ftemp, 4, 1, DMPFile, "SCALAR");
	ftemp = vzscale[isp] * vz[isp][i];
	XGWrite(&ftemp, 4, 1, DMPFile, "SCALAR");
      }
  }
  XGWrite(f_array, 4, freq_hi, DMPFile, "SCALAR");
  fclose(DMPFile);

  if (!theRunWithXFlag) {
    strcat(dmpfile, ".drp");
    if ((DMPFile = fopen(dmpfile, "w")) == NULL) {
      puts("Drop: open failed");
      return 0;
    }
    fprintf(DMPFile,"#### time\tNum_e\tNum_i\tFE\tmid_pot\n");
    for (i=0;i<hist_hi;i++) {
      if (nsp==1) ftemp=0;
      else       ftemp=np_hist[1][i];
      fprintf(DMPFile,"%e %6.4e %6.4e %6.4e %6.4e\n",t_array[i],
  	np_hist[0][i], ftemp, fe_hist[i], com_phi_hist[1][i]);
    }
    fclose(DMPFile);
  }
}

/****************************************************************/

int Restore(filename)
char *filename;
{
  char Rev[5];
  register int i, isp;
  int nsp0;
  SCALAR ftemp;
  FILE *DMPFile;

  if ((DMPFile = fopen(filename, "r+b")) == NULL) {
    puts("Dump: open failed");
    return 0;
  }

  printf("Reading in data from dumpfile %s\n",filename);

  XGRead(Rev, 1, 4, DMPFile, "char");
  for (i=0; i<4; i++)
    if (Rev[i]!=Revision[i]) {
      puts("Incompatible dump file version");
      exit(1);
    }

  XGRead(&ftemp, 4, 1, DMPFile, "SCALAR");
  t = ftemp;
  XGRead(&nsp0, 4, 1, DMPFile, "int");
  if (nsp0!=nsp) 
    puts("Warning! nsp in Dumpfile is different from that in input file.");
  XGRead(np, 4, nsp0, DMPFile, "int");

  for (isp=0; isp<nsp0; isp++) {

    for (i=0; i<np[isp]; i++) {
      XGRead(&ftemp, 4, 1, DMPFile, "SCALAR");
      r[isp][i] = ftemp*fncr;
      XGRead(&ftemp, 4, 1, DMPFile, "SCALAR");
      th[isp][i] = ftemp*fnct;
      XGRead(&ftemp, 4, 1, DMPFile, "SCALAR");
      vr[isp][i]= ftemp/vrscale[isp];
      XGRead(&ftemp, 4, 1, DMPFile, "SCALAR");
      vth[isp][i]= ftemp/vthscale[isp];
      XGRead(&ftemp, 4, 1, DMPFile, "SCALAR");
      vz[isp][i]= ftemp/vzscale[isp];

    }
  }
  XGRead(f_array, 4, freq_hi, DMPFile, "SCALAR");
  fclose(DMPFile);
}
