#include "pdc2.h"

SCALAR F(SCALAR);
/**************************************************************/
int maxwellv(vx, vy, vz, vth0)
     SCALAR *vx, *vy, *vz, vth0;
{
  static int nvel, init_flag= 1;
  static SCALAR *vsave_x, *vsave_y, *vsave_z;

  int i, n;
  SCALAR vmag, aphi, dv, rr, sintheta, costheta;

  if (init_flag) {
    nvel= 1./(1-F((SCALAR)NVTS));
    dv = sqrt(M_PI)/(4.0*nvel);
    if(nvel > 100000)
      puts("Warning: Your choice of NVTS has made nvel > 1e5");

    vsave_x= (SCALAR *) malloc(nvel*sizeof(SCALAR));
    vsave_y= (SCALAR *) malloc(nvel*sizeof(SCALAR));
    vsave_z= (SCALAR *) malloc(nvel*sizeof(SCALAR));

    init_flag= 0;
    i=n=0;
    for (n=0; n<nvel; n++) {
      rr=(1.0*n)/nvel;
      while (F(i*dv)< rr) i++;
      vmag=i*dv;
      aphi=2*M_PI*frand();
      costheta = 1-2*frand();
      sintheta = sqrt(1-costheta*costheta);
      vsave_x[n] = vmag*sintheta*cos(aphi);
      vsave_y[n] = vmag*sintheta*sin(aphi);
      vsave_z[n] = vmag*costheta;
    }
  }
  n = (nvel-1)*frand();
  *vx = vth0*vsave_x[n];
  *vy = vth0*vsave_y[n];
  *vz = vth0*vsave_z[n];
}

/**************************************************************/

SCALAR F(SCALAR v)
{
  return(-2*v*exp(-v*v)/sqrt(M_PI) +erf(v));
}

/**************************************************************/

void vmaxwellv(SCALAR *vx, SCALAR *vy, SCALAR *vz,
	       SCALAR vth0, SCALAR v0, int flag)
{
  SCALAR vx_temp, vy_temp, vz_temp, aphi, vmag;
  
  aphi= 2*M_PI*frand();
  vmag= sqrt(fabs(log(frand())));
  vx_temp = vth0*vmag*cos(aphi);
  vy_temp = vth0*vmag*sin(aphi);
  vz_temp = vth0*vmag+v0;
  
  if(flag== -3){
    *vx = -vx_temp; *vy = -vy_temp; *vz = -vz_temp;
  }
  else if(flag== -2){
    *vx = -vy_temp; *vy = -vz_temp; *vz = -vx_temp;
  }
  else if(flag== -1){
    *vx = -vz_temp; *vy = -vx_temp; *vz = -vy_temp;
  }
  else if(flag==  1){
    *vx =  vz_temp; *vy =  vx_temp; *vz =  vy_temp;
  }
  else if(flag==  2){
    *vx =  vy_temp; *vy =  vz_temp; *vz =  vx_temp;
  }
  else if(flag==  3){
    *vx =  vx_temp; *vy =  vy_temp; *vz =  vz_temp;
  }
}

/**************************************************************/

