#include "pdc2.h"

int mccdiag_init()
{
  register int i, j, k;
  
  if(ecollisional==0 && icollisional==0) {
    ndiag = 0;
    return 0;
  }
  
/* default gas = argon */

if ( (gas < HELIUM) || (gas > ARGON) ) gas = ARGON;

switch (gas) {

case HELIUM:
  ndiag = 4;
  
  rate_title = (char **)malloc(ndiag*sizeof(char *));
  rate_title[0]= "MCC Elastic";
  rate_title[1]= "MCC Excitation";
  rate_title[2]= "MCC Ionization";
  rate_title[3]= "MCC Charge X";
  break;
  
case ARGON:
  ndiag = 5;
  
  rate_title = (char **)malloc(ndiag*sizeof(char *));
  rate_title[0]= "MCC Elastic";
  rate_title[1]= "MCC Excitation";
  rate_title[2]= "MCC Ionization";
  rate_title[3]= "MCC Scattering";
  rate_title[4]= "MCC Charge X";
  break;
}
  
  /*  Allocate arrays for diagnostic rates */
  mccrate  = (SCALAR ***)malloc(ndiag*sizeof(SCALAR *));
  rate_show= (SCALAR ***)malloc(ndiag*sizeof(SCALAR *));
  for(i=0; i<ndiag; i++) {
    mccrate[i]  = (SCALAR **)malloc(ngr*sizeof(SCALAR));
    rate_show[i]= (SCALAR **)malloc(ngr*sizeof(SCALAR));
    for (j=0; j<ngr; j++) {
      mccrate[i][j] = (SCALAR *)malloc(ngt*sizeof(SCALAR));
      rate_show[i][j] = (SCALAR *)malloc(ngt*sizeof(SCALAR));
      for (k=0; k<ngt; k++) mccrate[i][j][k]=rate_show[i][j][k]=0;
    }
  }
  for(i=0; i<ndiag; i++) 
    for (j=0; j<ngr; j++)
      for (k=0; k<ngt; k++) mccrate[i][j][k]=rate_show[i][j][k]=0; 
}
