/* 
  Revision History:

  .05        Started with PDC1 and looked at ways to make it two-d
  .1  Alpha  Started with PDP2 and made it R-Theta. Field solve 
             and most important parts are checked for the first time.
  .2  Beta   Program written. Beginning of serious checks and bugs.
  .9  Gamma  Working phyiscs kernel. Bug fixes and diagnostic additions
# P.G.
  1.0 Add Collisions with MCC package
*/

#ifndef _INCLUDE_POSIX_SOURCE
#define _INCLUDE_POSIX_SOURCE 1
#endif


#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "xgscalar.h"

#ifndef M_PI
#define M_PI              3.14159265358979323846
#define PI 3.141592653589793
#endif
#define PI 3.141592653589793
#define TWOPI 6.28318530717959
#define JO 2.4048255577 /* First zero of Jo */
#define EPS0 8.8542e-12			/* (F/m)  */
#define NSMAX 		3
#define NBIN            256
#define HISTMAX         8192
#define NVTS            3.3
#define NperTORR        8.3221e20
#define HELIUM          1
#define ARGON           2

#ifndef max
#define max(x, y)       (((x) > (y)) ? (x) : (y))
#endif

#ifndef min
#define min(x, y)       (((x) < (y)) ? (x) : (y))
#endif

#ifndef DBL_MIN
#define DBL_MIN         1E-30
#endif

#ifndef True
#define True            1
#endif

#ifndef False
#define False           0
#endif

/*******************************************************************/

SCALAR nc2p, fncr, fnct, rlength, tlength, zlength, rhoback, backj,
  epsilon, sigma, dr, dth, dt,dt2,drdthzlength, *vol, *vol2, epsdth2, pidrdr,
  se,dr2,dth2,area0,ex,ey,bmag,bphi,btheta,ttmag,rmin,rmax,moder,
  max_ang,area,rmaxn,rminn,df,risetime,b0,oldsigma,exti,jp,rho0, pidrdrzlength;

char prompt, **rate_title;

SCALAR vt[NSMAX], q[NSMAX], m[NSMAX], qm[NSMAX], Exscale[NSMAX], 
  Eyscale[NSMAX], Ezscale[NSMAX],v0x[NSMAX],v0y[NSMAX],v0z[NSMAX],
  vrscale[NSMAX], vthscale[NSMAX], vzscale[NSMAX],a_scale[NSMAX],
  ttx[NSMAX],tty[NSMAX],ttz[NSMAX],ssx[NSMAX],ssy[NSMAX],ssz[NSMAX],
  extr, extl, extc, extq, extq_1, extq_2, extq_3,
  jwall[NSMAX], pressure, gtemp, selsmax, elsengy0, elsengy1, 
  elsengy2, sextmax, extengy0, extengy1, extengy2, sionmax, ionengy0,
  ionengy1, ionengy2,achrgx, bchrgx, ascat, bscat, seec[NSMAX], T[NSMAX],
  LambdaD[NSMAX],*phasebin,*phasenum,enter[NSMAX], gyro_flag[NSMAX];

int nsp, ncr, ngr, nct, ngt, fftngt, np[NSMAX],hist_hi,boundn, 
  interval,modsrt,modend,num_modes,numphase,ntimestep, freq_hi, num_kth, 
  nfft, thist_hi, sheath, secondary, secsp, ecolsp, icolsp, ionsp,ntri,
  ecollisional, icollisional,reflux,cent_cond,cflag,inject[NSMAX],
  maxnp[NSMAX];

SCALAR **r, **th, **x, **y, **x_i, **y_i, **vr, **vth, **vz, *r_array, 
  *th_array, *k_array, ***srho, **rho, **er, **eth, **phi, **rhok, **phik, 
  **phi_i, *sigma_wall, *gam, *A,**B, *C,**fft_rho,**fft_phi,**w1,**w2,
  **w3,**w4,**ar,**ath,*boundxmn,*boundymn, *t_array,**np_hist, **kes_hist,
  *ke_hist,*fe_hist,*te_hist,**fes_hist, *cos_array, *sin_array, **phi_r_kth_t,
  **phi_r_kth_f, *f_array, *Local_t_array, *phi_r_klo_t, *phi_r_khi_t,
  *phi_r_klo_f, *phi_r_khi_f, *phi_r_khi2_f, *phi_r_khi3_f, *rg,*com_cur_hist,
  *sigma_hist,***rate_show,***mccrate, **vx1, **vy1,**com_phi_hist,
  **phi_ave, **phi_ave_show, **er_ave, **er_ave_show, **eth_ave, **eth_ave_show,
  *boundxmx,*boundymx, **com_e_hist, *cur_hist, *cur_fft, *phi_fft, *er_fft,
  *eth_fft,**phi_hist, **e_hist;

SCALAR t;

int   *k_count, *sp_k, nsmooth, loader[NSMAX], BCflag, bias_grid,
      inject_max_np[NSMAX], ndiag, gas, iter, inner_mode, outer_mode,
      hngt, hngr, ngfactor_r, ngfactor_t;
      
SCALAR ***srho0, *er_r_show, *phi_r_show, *eth_r_show, **srho_r_show, **loc_ese,
      ***srho1, **dust_rho, **sr0, **sth0, **sr1, **sth_width, ***sp_n_mcc,
      inner_dc, inner_ac, inner_f0, inner_t0, outer_dc, outer_ac, outer_f0, 
      outer_t0, delta1, delta2, bias_volt, *r_array2, *th_array2, *fe_hist_old,
      **er2, **eth2, *mode_hist, r_width, *dt_hist, dt_min1, dt_min2, dt_min3;
SCALAR *cem_hist, *a_momentum_hist;

SCALAR frand(), revers(), bc1(), bc2(), bc3(), bc4(), (*bcptr)();  
void  circuit1(), circuit2(), circuit3(), circuit4(), (*circuitptr)();
void  fields(),gather(),nfields(),ngather(),(*fieldsptr)(),(*gatherptr)();
void  heliummcc(), argonmcc (), (*mccptr)();
void  (*move_ptr)(int isp), move(int isp), mag_move(int isp);
SCALAR bit_rever_maxwell(), random_maxwell();
